//+------------------------------------------------------------------+
//|                                                  Canvas_Test.mq5 |
//|                                       Copyright 2012, MetaDriver |
//|                                            MetaDriver@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaDriver"
#property link      "MetaDriver@rambler.ru"
#property version   "1.00"
#include <2Alpha_Canvas.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CMovingPoint
  {
   int x,y,dx,dy,
   lbord,rbord,tbord,bbord;
public:
                     CMovingPoint(){}
                    ~CMovingPoint(void) {}
   void             Init(int X,int Y,int dX,int dY,
                         int lBorder,int rBorder,int tBorder,int bBorder)
     {
      x=(X); y=(Y); dx=(dX); dy=(dY);
      lbord=(lBorder); rbord=(rBorder);
      tbord=(tBorder);
      bbord=(bBorder);
     }
   void NextStep()
     {
      x+=dx; if(x<lbord || x>rbord) dx*=-1;
      y+=dy; if(y<tbord || y>bbord) dy*=-1;
     }
   int X() {return x;}
   int Y() {return y;}
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CMovingTriangle
  {
   CMovingPoint      p1,p2,p3;
   uint              col;
   CCanvas          *space;
public:
                     CMovingTriangle(void){}
                    ~CMovingTriangle(void){}
   void  RandomCreate(CCanvas *Space,int left,int right,int top,int bottom,uint Color)
     {
      space=Space;  col=Color;
      p1.Init(rand()%(right-left)+left,rand()%(bottom-top)+top,
              rand()%11-5,rand()%7-3,left,right,top,bottom);
      p2.Init(rand()%(right-left)+left,rand()%(bottom-top)+top,
              rand()%11-5,rand()%7-3,left,right,top,bottom);
      p3.Init(rand()%(right-left)+left,rand()%(bottom-top)+top,
              rand()%11-5,rand()%7-3,left,right,top,bottom);
     }
   void NextStep() {p1.NextStep(); p2.NextStep(); p3.NextStep(); }
   void Draw() {space.FillTriangle(p1.X(),p1.Y(),p2.X(),p2.Y(),p3.X(),p3.Y(),col);}
   void NextDraw() {NextStep(); Draw();}
  };
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   CCanvas can;
//---
   can.Create("MySpace",0,0,512,512,COLOR_FORMAT_ARGB_NORMALIZE);
   MathSrand(GetTickCount());
//---
   for(int i=0;i<100;i++)
     {
      can.FillRect(MathRand()&255,MathRand()&255,256+(MathRand()&255),256+(MathRand()&255),ARGB(150,MathRand(),MathRand(),MathRand()));
      can.FillCircle(MathRand()&511,MathRand()&511,MathRand()&127,ARGB(200,MathRand(),MathRand(),MathRand()));
      can.FillTriangle(MathRand()&511,MathRand()&511,MathRand()&511,MathRand()&511,MathRand()&511,MathRand()&511,ARGB(180,MathRand(),MathRand(),MathRand()));
      //---
      can.Update(); // Sleep(600);
     }
   CMovingTriangle T1,T2,T3;
   T1.RandomCreate(GetPointer(can),5,502,6,500, 0xddf08060);
   T2.RandomCreate(GetPointer(can),5,502,6,500, 0xcc6080a0);
   T3.RandomCreate(GetPointer(can),5,502,6,500, 0xcc60eb90);
   while(!IsStopped())
     {
      T1.NextDraw();
      T2.NextDraw();
      T3.NextDraw();
      can.Update();
      Sleep(2);
     }
//---
  }
//+------------------------------------------------------------------+
